/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the ConditionExpression type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ConditionExpression{}

// ConditionExpression struct for ConditionExpression
type ConditionExpression struct {
	Source string `json:"source"`
	Value string `json:"value"`
}

// NewConditionExpression instantiates a new ConditionExpression object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewConditionExpression(source string, value string) *ConditionExpression {
	this := ConditionExpression{}
	this.Source = source
	this.Value = value
	return &this
}

// NewConditionExpressionWithDefaults instantiates a new ConditionExpression object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewConditionExpressionWithDefaults() *ConditionExpression {
	this := ConditionExpression{}
	return &this
}

// GetSource returns the Source field value
func (o *ConditionExpression) GetSource() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Source
}

// GetSourceOk returns a tuple with the Source field value
// and a boolean to check if the value has been set.
func (o *ConditionExpression) GetSourceOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Source, true
}

// SetSource sets field value
func (o *ConditionExpression) SetSource(v string) {
	o.Source = v
}

// GetValue returns the Value field value
func (o *ConditionExpression) GetValue() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Value
}

// GetValueOk returns a tuple with the Value field value
// and a boolean to check if the value has been set.
func (o *ConditionExpression) GetValueOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Value, true
}

// SetValue sets field value
func (o *ConditionExpression) SetValue(v string) {
	o.Value = v
}

func (o ConditionExpression) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ConditionExpression) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["source"] = o.Source
	toSerialize["value"] = o.Value
	return toSerialize, nil
}

type NullableConditionExpression struct {
	value *ConditionExpression
	isSet bool
}

func (v NullableConditionExpression) Get() *ConditionExpression {
	return v.value
}

func (v *NullableConditionExpression) Set(val *ConditionExpression) {
	v.value = val
	v.isSet = true
}

func (v NullableConditionExpression) IsSet() bool {
	return v.isSet
}

func (v *NullableConditionExpression) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableConditionExpression(val *ConditionExpression) *NullableConditionExpression {
	return &NullableConditionExpression{value: val, isSet: true}
}

func (v NullableConditionExpression) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableConditionExpression) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


